commit 364e4a96e312dc7eac361c0a14e70fefbfd9bcfb
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Fri Mar 4 02:03:57 2011 +0100

    [licence] updated copyright years

diff --git a/lib/cyborghood-librarian/land.rb b/lib/cyborghood-librarian/land.rb
index 0869ba9..8eba6f1 100644
--- a/lib/cyborghood-librarian/land.rb
+++ b/lib/cyborghood-librarian/land.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-librarian/records.rb b/lib/cyborghood-librarian/records.rb
index e670182..7d67390 100644
--- a/lib/cyborghood-librarian/records.rb
+++ b/lib/cyborghood-librarian/records.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-librarian/records/dns_domain.rb b/lib/cyborghood-librarian/records/dns_domain.rb
index d3d55e0..b41646d 100644
--- a/lib/cyborghood-librarian/records/dns_domain.rb
+++ b/lib/cyborghood-librarian/records/dns_domain.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-librarian/records/person.rb b/lib/cyborghood-librarian/records/person.rb
index 293712c..0b77456 100644
--- a/lib/cyborghood-librarian/records/person.rb
+++ b/lib/cyborghood-librarian/records/person.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-mapmaker/dns/base.rb b/lib/cyborghood-mapmaker/dns/base.rb
index ca2c723..28b3dc8 100644
--- a/lib/cyborghood-mapmaker/dns/base.rb
+++ b/lib/cyborghood-mapmaker/dns/base.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-mapmaker/dns/bind.rb b/lib/cyborghood-mapmaker/dns/bind.rb
index e6f2e2a..872114c 100644
--- a/lib/cyborghood-mapmaker/dns/bind.rb
+++ b/lib/cyborghood-mapmaker/dns/bind.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-mapmaker/dnssec/base.rb b/lib/cyborghood-mapmaker/dnssec/base.rb
index 3a646d0..4fc1bee 100644
--- a/lib/cyborghood-mapmaker/dnssec/base.rb
+++ b/lib/cyborghood-mapmaker/dnssec/base.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-mapmaker/dnssec/opendnssec.rb b/lib/cyborghood-mapmaker/dnssec/opendnssec.rb
index b12482d..b774e34 100644
--- a/lib/cyborghood-mapmaker/dnssec/opendnssec.rb
+++ b/lib/cyborghood-mapmaker/dnssec/opendnssec.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-mapmaker/land.rb b/lib/cyborghood-mapmaker/land.rb
index 94487d0..b30e834 100644
--- a/lib/cyborghood-mapmaker/land.rb
+++ b/lib/cyborghood-mapmaker/land.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-mapmaker/zone.rb b/lib/cyborghood-mapmaker/zone.rb
index 55585e9..9819cc9 100644
--- a/lib/cyborghood-mapmaker/zone.rb
+++ b/lib/cyborghood-mapmaker/zone.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-mapmaker/zone_content.rb b/lib/cyborghood-mapmaker/zone_content.rb
index be8e5ca..754df32 100644
--- a/lib/cyborghood-mapmaker/zone_content.rb
+++ b/lib/cyborghood-mapmaker/zone_content.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood-mapmaker/zone_editor.rb b/lib/cyborghood-mapmaker/zone_editor.rb
index 1f332f1..3885601 100644
--- a/lib/cyborghood-mapmaker/zone_editor.rb
+++ b/lib/cyborghood-mapmaker/zone_editor.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood.rb b/lib/cyborghood.rb
index 17259c5..12f7572 100644
--- a/lib/cyborghood.rb
+++ b/lib/cyborghood.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/config.rb b/lib/cyborghood/base/config.rb
index f6badee..87e5b37 100644
--- a/lib/cyborghood/base/config.rb
+++ b/lib/cyborghood/base/config.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/exceptions.rb b/lib/cyborghood/base/exceptions.rb
index c029781..548164c 100644
--- a/lib/cyborghood/base/exceptions.rb
+++ b/lib/cyborghood/base/exceptions.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/info.rb b/lib/cyborghood/base/info.rb
index ed66a36..25f179b 100644
--- a/lib/cyborghood/base/info.rb
+++ b/lib/cyborghood/base/info.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/lang_additions.rb b/lib/cyborghood/base/lang_additions.rb
index 72e3644..b9c2f04 100644
--- a/lib/cyborghood/base/lang_additions.rb
+++ b/lib/cyborghood/base/lang_additions.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/language.rb b/lib/cyborghood/base/language.rb
index dfb391c..8af2e8d 100644
--- a/lib/cyborghood/base/language.rb
+++ b/lib/cyborghood/base/language.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/base/logger.rb b/lib/cyborghood/base/logger.rb
index 35b4949..2dd757e 100644
--- a/lib/cyborghood/base/logger.rb
+++ b/lib/cyborghood/base/logger.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/command_runner.rb b/lib/cyborghood/command_runner.rb
index a43ff9f..02518bc 100644
--- a/lib/cyborghood/command_runner.rb
+++ b/lib/cyborghood/command_runner.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg.rb b/lib/cyborghood/cyborg.rb
index ae3ac5b..067c21a 100644
--- a/lib/cyborghood/cyborg.rb
+++ b/lib/cyborghood/cyborg.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg/botnet.rb b/lib/cyborghood/cyborg/botnet.rb
index 357a3c5..58f2d27 100644
--- a/lib/cyborghood/cyborg/botnet.rb
+++ b/lib/cyborghood/cyborg/botnet.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg/botnet/backend/unix.rb b/lib/cyborghood/cyborg/botnet/backend/unix.rb
index 48052f0..d795ae6 100644
--- a/lib/cyborghood/cyborg/botnet/backend/unix.rb
+++ b/lib/cyborghood/cyborg/botnet/backend/unix.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg/botnet/conversation.rb b/lib/cyborghood/cyborg/botnet/conversation.rb
index 62ad1d7..6c7ac72 100644
--- a/lib/cyborghood/cyborg/botnet/conversation.rb
+++ b/lib/cyborghood/cyborg/botnet/conversation.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg/botnet/dsl.rb b/lib/cyborghood/cyborg/botnet/dsl.rb
index 0f48fd6..fbb26a6 100644
--- a/lib/cyborghood/cyborg/botnet/dsl.rb
+++ b/lib/cyborghood/cyborg/botnet/dsl.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg/botnet/interface.rb b/lib/cyborghood/cyborg/botnet/interface.rb
index 19f7361..bd9731e 100644
--- a/lib/cyborghood/cyborg/botnet/interface.rb
+++ b/lib/cyborghood/cyborg/botnet/interface.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg/botnet/protocol.rb b/lib/cyborghood/cyborg/botnet/protocol.rb
index d77fa7b..b0ffd76 100644
--- a/lib/cyborghood/cyborg/botnet/protocol.rb
+++ b/lib/cyborghood/cyborg/botnet/protocol.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg/botnet/session.rb b/lib/cyborghood/cyborg/botnet/session.rb
index a356ac6..3bed6f9 100644
--- a/lib/cyborghood/cyborg/botnet/session.rb
+++ b/lib/cyborghood/cyborg/botnet/session.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/cyborg/dsl.rb b/lib/cyborghood/cyborg/dsl.rb
index 8480b13..0657033 100644
--- a/lib/cyborghood/cyborg/dsl.rb
+++ b/lib/cyborghood/cyborg/dsl.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/imap.rb b/lib/cyborghood/imap.rb
index 9491e0b..6862bd9 100644
--- a/lib/cyborghood/imap.rb
+++ b/lib/cyborghood/imap.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/mail.rb b/lib/cyborghood/mail.rb
index 4f8f973..47701f9 100644
--- a/lib/cyborghood/mail.rb
+++ b/lib/cyborghood/mail.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/mail_order.rb b/lib/cyborghood/mail_order.rb
index 3082d49..3458e79 100644
--- a/lib/cyborghood/mail_order.rb
+++ b/lib/cyborghood/mail_order.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/objects.rb b/lib/cyborghood/objects.rb
index c9373f7..1566f79 100644
--- a/lib/cyborghood/objects.rb
+++ b/lib/cyborghood/objects.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/cyborghood/order.rb b/lib/cyborghood/order.rb
index 34f553e..76b5555 100644
--- a/lib/cyborghood/order.rb
+++ b/lib/cyborghood/order.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/tmail_extra.rb b/lib/tmail_extra.rb
index f654e2f..b7b6076 100644
--- a/lib/tmail_extra.rb
+++ b/lib/tmail_extra.rb
@@ -1,6 +1,6 @@
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/lib/tmail_gpg.rb b/lib/tmail_gpg.rb
index e6897d9..696c286 100644
--- a/lib/tmail_gpg.rb
+++ b/lib/tmail_gpg.rb
@@ -1,5 +1,5 @@
 #--
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # Permission is hereby granted, free of charge, to any person obtaining
 # a copy of this software and associated documentation files (the
diff --git a/post-clean.rb b/post-clean.rb
index a47cb6d..fa3c558 100644
--- a/post-clean.rb
+++ b/post-clean.rb
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/post-config.rb b/post-config.rb
index 71d7e48..5582125 100644
--- a/post-config.rb
+++ b/post-config.rb
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,7 +24,7 @@ header = <<HEADER
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
diff --git a/post-setup.rb b/post-setup.rb
index 591e679..3e99b1d 100644
--- a/post-setup.rb
+++ b/post-setup.rb
@@ -2,7 +2,7 @@
 
 #--
 # CyborgHood, a distributed system management software.
-# Copyright (c) 2009-2010 Marc Dequènes (Duck) <Duck@DuckCorp.org>
+# Copyright (c) 2009-2011 Marc Dequènes (Duck) <Duck@DuckCorp.org>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by