commit 726b6765554f493220a8c47be896abc0dd6bef8f
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Fri Sep 9 21:19:08 2011 +0200

    [evol] attributes parameters rework § (MilkyPond world update) (refs #142)

diff --git a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/aspects/fs.conf b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/aspects/fs.conf
index 4b41234..b913782 100644
--- a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/aspects/fs.conf
+++ b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/aspects/fs.conf
@@ -2,8 +2,18 @@
 mapping:
   classes: ['fsUser']
   associated_relations: ['primaryGroup', 'secondaryGroups']
-presentation:
-  expert_attributes: ['uidNumber', 'gidNumber', 'gecos']
+interface:
+  attributes:
+    'uidNumber':
+      visibility: expert
+    'gidNumber':
+      visibility: expert
+    'gecos':
+      visibility: expert
+    'primaryGroup':
+      presentation_multiple: shortlist
+    'secondaryGroups':
+      presentation_multiple: shortlist
 relations:
   primaryGroup:
     type: belongs_to
diff --git a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/bot.conf b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/bot.conf
index 2abc8c8..9e2806d 100644
--- a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/bot.conf
+++ b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/bot.conf
@@ -6,5 +6,7 @@ mapping:
   sort_by: uid
   possible_aspects: ['primary_account', 'mail', 'fs', 'shell', 'ftp', 'web', 'jabber']
   default_parent: "unit/SpecialAccounts"
-presentation:
-  hidden_attributes: ['uid']
+interface:
+  attributes:
+    'uid':
+      visibility: admin
diff --git a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/entity.conf b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/entity.conf
index ebff019..8a25ffb 100644
--- a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/entity.conf
+++ b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/entity.conf
@@ -8,9 +8,11 @@ mapping:
   associated_relations: ['foundersIndividuals', 'foundersEntities']
   parent_handle_restrictions: "^unit/Entities$"
   default_parent: "unit/Entities"
-presentation:
+interface:
   name_attribute: o
-  hidden_attributes: ['founder']
+  attributes:
+    'founder':
+      visibility: admin
 relations:
   foundersIndividuals:
     type: has_many
diff --git a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/group.conf b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/group.conf
index 6e3efdf..64f0fd4 100644
--- a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/group.conf
+++ b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/group.conf
@@ -5,9 +5,20 @@ mapping:
   classes: ['posixGroup', 'groupOfMembers']
   sort_by: cn
   associated_relations: ['individualsPrimaryMembers', 'botsPrimaryMembers', 'individualsSecondaryMembers', 'botsSecondaryMembers']
-presentation:
-  hidden_attributes: ['uniqueMember']
-  expert_attributes: ['gidNumber']
+interface:
+  attributes:
+    'uniqueMember':
+      visibility: admin
+    'gidNumber':
+      visibility: expert
+    'individualsPrimaryMembers':
+      presentation_multiple: shortlist
+    'botsPrimaryMembers':
+      presentation_multiple: shortlist
+    'individualsSecondaryMembers':
+      presentation_multiple: shortlist
+    'botsSecondaryMembers':
+      presentation_multiple: shortlist
 relations:
   individualsPrimaryMembers:
     type: belongs_to
diff --git a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/individual.conf b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/individual.conf
index a35623d..c1ea4b2 100644
--- a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/individual.conf
+++ b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/individual.conf
@@ -7,5 +7,7 @@ mapping:
   possible_aspects: ['primary_account', 'mail', 'fs', 'shell', 'ftp', 'web', 'jabber']
   parent_handle_restrictions: "^unit/People$"
   default_parent: "unit/People"
-presentation:
-  hidden_attributes: ['uid']
+interface:
+  attributes:
+    'uid':
+      visibility: admin
diff --git a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/top_entity.conf b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/top_entity.conf
index a4be6c7..9439b23 100644
--- a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/top_entity.conf
+++ b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/top_entity.conf
@@ -5,5 +5,5 @@ mapping:
   classes: ['entity', 'dcObject']
   sort_by: o
   parent_handle_restrictions: "^$"
-presentation:
+interface:
   name_attribute: o
diff --git a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/unit.conf b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/unit.conf
index 9de9245..360a620 100644
--- a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/unit.conf
+++ b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/objects/unit.conf
@@ -4,5 +4,5 @@ mapping:
   prefix: ''
   classes: ['organizationalUnit']
   # no sort_by means sort by DN
-presentation:
+interface:
   name_attribute: dn
diff --git a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/shadow.conf b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/shadow.conf
index 6f9d97b..827730c 100644
--- a/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/shadow.conf
+++ b/conf/ldap_shadows/worlds/MilkyPond/shadows/Administration/shadow.conf
@@ -1,4 +1,25 @@
 ---
-presentation:
-  hidden_attributes: ['objectClass', 'userPassword', 'hasSubordinates', 'entryUUID', 'entryDN', 'structuralObjectClass', 'subschemaSubentry']
+interface:
   tree_objects: ['unit', 'entity']
+  attributes:
+    'objectClass':
+      access: read_only
+      visibility: admin
+      presentation_multiple: shortlist
+    'userPassword':
+      access: write_only
+    'hasSubordinates':
+      access: read_only
+      visibility: admin
+    'entryUUID':
+      access: read_only
+      visibility: admin
+    'entryDN':
+      access: read_only
+      visibility: admin
+    'structuralObjectClass':
+      access: read_only
+      visibility: admin
+    'subschemaSubentry':
+      access: read_only
+      visibility: admin